unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLCoordinates, GLCrossPlatform, BaseClasses,
  GLWin32Viewer, StdCtrls, ExtCtrls, math,
  VectorTypes, VectorGeometry,
  GLGeomObjects;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    raiz: TGLDummyCube;
    Panel1: TPanel;
    Button1: TButton;
    GLPolygon1: TGLPolygon;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    x1,y1,x2,y2  : single;
    nx,ny        : integer;
    xc,yc,zc     : single;
    L            : single;
    ZZ           : array of array of single;

    px,py        : integer;

    procedure adquiere_datos();
    procedure evaluar();
    procedure caja();
    procedure escalar();
    procedure trazar();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
function fun (x,y : single): single;
begin
  fun := exp(-x*x-y*y);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X; py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X; py := Y;
  end;
end;

// aquiere datos
procedure TForm1.adquiere_datos();
begin
   x1 := -2; y1 := -2;
   x2 :=  2; y2 :=  2;
   nx := 20; ny := 20;
end;

// evaluacion
procedure TForm1.evaluar();
var
  dx,dy,xx,yy : single;
  i,j         : integer;
begin
  dx := (x2-x1)/(nx-1);
  dy := (y2-y1)/(ny-1);
  SetLength(ZZ,nx,ny);
  yy := y1;
  for j := 0 to ny - 1 do begin
    xx := x1;
    for i := 0 to nx - 1 do begin
      ZZ[i][j] := fun(xx,yy);
      xx := xx + dx;
    end;
    yy := yy + dy;
  end;
end;

// Caja de contencion
procedure TForm1.caja();
var
  i, j     : integer;
  Zmi,Zma  : single;
begin
  Zmi  := ZZ[0][0];
  Zma  := Zmi;

  for j := 0 to ny - 1 do
    for i := 0 to nx - 1 do begin
      Zmi := MIN(Zmi,ZZ[i][j]);
      Zma := MAX(Zma,ZZ[i][j]);
    end;

  L := MAX(x2-x1,y2-y1);
  L := MAX(L,Zma-Zmi);

  xc := (x1  +  x2)/2;
  yc := (y1  +  y2)/2;
  zc := (Zma + Zmi)/2;
end;

// escalar
procedure TForm1.escalar();
var
  i,j  : integer;
begin
  for j := 0 to ny - 1 do
    for i := 0 to nx - 1 do
      ZZ[i][j]  := 2*(ZZ[i][j]-zc)/L
end;

// trazar
procedure TForm1.trazar();
var
  i,j,i1,j1   : integer;
  xi,yi,xd,yd : single;
  xx,yy       : single;
  dx,dy       : single;
  parche      : TGLPolygon;
  v0,v1,v2,v3 : TVector3f;
begin
  dx := (x2-x1)/(nx-1);
  dy := (y2-y1)/(ny-1);

  yy := y1;
  yi := 2*(yy-yc)/L; yd := 2*(yy + dy - yc)/L;
  for j := 0 to ny - 2 do begin
    j1 := succ(j);
    xx := x1;
    xi := 2*(xx-xc)/L; xd := 2*(xx + dx - xc)/L;
    for i := 0 to nx - 2 do begin
       i1 := succ(i);

       SetVector(v0, xi, yi, ZZ[i ][j ]);
       SetVector(v1, xd, yi, ZZ[i1][j ]);
       SetVector(v2, xi, yd, ZZ[i ][j1]);
       SetVector(v3, xd, yd, ZZ[i1][j1]);

       parche := TGLPolygon.Create(self);
       parche.Parent := raiz;
       parche.Nodes.AddNode(v0);
       parche.Nodes.AddNode(v1);
       parche.Nodes.AddNode(v2);

       parche := TGLPolygon.Create(self);
       parche.Parent := raiz;
       parche.Nodes.AddNode(v1);
       parche.Nodes.AddNode(v3);
       parche.Nodes.AddNode(v2);

       xi := xd;
       xx := xx + dx;
       xd := 2*(xx + dx - xc)/L;
    end;
    yi := yd;
    yy := yy + dy;
    yd := 2*(yy + dy - yc)/L;
  end;
end;

// trazar
procedure TForm1.Button1Click(Sender: TObject);
begin
  adquiere_datos();
  evaluar();
  caja();
  escalar();
  trazar();
end;


end.
